%maxmin ver0.10a XV20131020
function maxmin

format_f='config/format.txt';
outputmax_f='max_exam.csv';
outputmin_f='min_exam.csv';

prompt = 'year(yyyy)?';
yr=input(prompt);

prompt = 'month(mm)? ';
mn=input(prompt);

[imax,jmax,variablename,dir_input_f,dir_output_f,d_start,d_end]=read_configfile(format_f);

great=zeros(imax,jmax);
least(1:imax,1:jmax)=1400.0;
num_grid=zeros(imax,jmax);

for dy=d_start:d_end
    for hr=0:23
        for min=0:59

            ut=jst2utc(yr,mn,dy,hr,min,0);
            examfile=make_filename(ut,variablename,dir_input_f);

            if exist(examfile) == 2

                fprintf('%s\n',examfile);

                fid_inputfile=fopen(examfile,'r','b');
                pickup=fread(fid_inputfile,[imax,jmax],'single');

                for grdj=1:jmax
                    for grdi=1:imax
                        if pickup(grdi,grdj) > great(grdi,grdj)
                            great(grdi,grdj)=pickup(grdi,grdj);
                        end
                        if pickup(grdi,grdj) < least(grdi,grdj)
                            least(grdi,grdj)=pickup(grdi,grdj);
                        end
                    end
                end
                fclose(fid_inputfile);
            end
        end
    end
end

fid_max=fopen(strcat(dir_output_f,outputmax_f),'w');
fid_min=fopen(strcat(dir_output_f,outputmin_f),'w');

for grdj=1:jmax
    for grdi=1:imax-1
        fprintf(fid_max,'%8.3f,',great(grdi,grdj));
        fprintf(fid_min,'%8.3f,',least(grdi,grdj));
    end
    grdi=imax;
    fprintf(fid_max,'%8.3f\n',great(grdi,grdj));
    fprintf(fid_min,'%8.3f\n',least(grdi,grdj));
end 

fclose(fid_max);
fclose(fid_min);
end


function ut=jst2utc(yr,mn,dy,hr,min,sec)

t_zone=9;
t = datenum(yr,mn,dy,hr,min,sec);

%fprintf('JST %s\n',datestr(t));

ut= addtodate(t, -1*t_zone, 'hour');

%fprintf('UTC %s\n',datestr(ut));
end


function [imax,jmax,variablename,dir_input_f,dir_output_f,d_start,d_end]=read_configfile(format_f)

fid_config=fopen(format_f,'r');

cline = fgetl(fid_config);
c = strsplit(cline);
cimax=c{1};
imax=str2num(cimax);
fprintf('%u\n',imax);

cline = fgetl(fid_config);
c = strsplit(cline);
cjmax=c{1};
jmax=str2num(cjmax);
fprintf('%u\n',jmax);

cline = fgetl(fid_config);
c = strsplit(cline);
variablename=c{1};
fprintf('%s\n',variablename);

cline = fgetl(fid_config);
c = strsplit(cline);
dir_input_f=c{1};
fprintf('%s\n',dir_input_f);

for i=1:4
    cline = fgetl(fid_config);
end

cline = fgetl(fid_config);
c = strsplit(cline);
dir_output_f=c{1};
fprintf('%s\n',dir_output_f);

for i=1:7
    cline = fgetl(fid_config);
end

cline = fgetl(fid_config);
c = strsplit(cline);
cd_start=c{1};
d_start=str2num(cd_start);
fprintf('%u\n',d_start);

cline = fgetl(fid_config);
c = strsplit(cline);
cd_end=c{1};
d_end=str2num(cd_end);
fprintf('%u\n',d_end);

fclose(fid_config);
end


function filename=make_filename(ut,variablename,dir_input_f)

vecut = datevec(ut);

yr=int2str(vecut(1));

if vecut(2) >=10
    mon=int2str(vecut(2));
else
    mon=strcat('0',int2str(vecut(2)));
end

if vecut(3) >=10
    dy=int2str(vecut(3));
else
    dy=strcat('0',int2str(vecut(3)));
end

if vecut(4) >=10
    hr=int2str(vecut(4));
else
    hr=strcat('0',int2str(vecut(4)));
end

if vecut(5) >=10
    min=int2str(vecut(5));
else
    min=strcat('0',int2str(vecut(5)));
end

if vecut(6) >=10
    sc=int2str(vecut(6));
else
    sc=strcat('0',int2str(vecut(6)));
end

cyr=strcat(yr,mon,dy,hr,min);

filename=strcat(dir_input_f,cyr,variablename,'.bin');
%fprintf('%s\n',filename);
end
